<?php

App::uses('Utility', 'Lib');
App::uses('Message', 'Lib');
App::uses('CustomEmail', 'Lib');

class ApiController extends AppController
{

    //public $components = array('Email');

    public $autoRender = false;
    public $layout = false;


    public function beforeFilter()
    {



        $this->loadModel('User');
        $json = file_get_contents('php://input');
        $json_error = Utility::isJsonError($json);

        if ($this->request->isPost()) {

            if (!function_exists('apache_request_headers')) {
                $headers = Utility::apache_request_headers();
            } else {
                $headers = apache_request_headers();
            }


            $user_id = 0;
            if (array_key_exists("User-Id", $headers)) {
                $user_id = $headers['User-Id'];

            } else if (array_key_exists("USER-ID", $headers)) {

                $user_id = $headers['USER-ID'];
            }





            $client_api_key = 0;
            if (array_key_exists("Api-Key", $headers)) {
                $client_api_key = $headers['Api-Key'];

            } else if (array_key_exists("API-KEY", $headers)) {

                $client_api_key = $headers['API-KEY'];
            } else if (array_key_exists("api-key", $headers)) {

                $client_api_key = $headers['api-key'];
            }


            if ($client_api_key > 0) {


                if ($client_api_key != API_KEY) {

                    Message::ACCESSRESTRICTED();
                    die();

                }
            } else {
                $output['code'] = 201;
                $output['msg'] = "API KEY is missing";

                echo json_encode($output);
                die();

            }

            if ($user_id > 0) {


                $userDetails = $this->User->getUserDetailsFromID($user_id);

                if (count($userDetails) > 0) {


                    $social = $userDetails['User']['social'];
                    $db_auth_token = $userDetails['User']['auth_token'];
                    $active = $userDetails['User']['active'];


                    if ($active > 1) {


                        $output['code'] = 501;
                        $output['msg'] = "You have been blocked by the admin. Contact support";
                        echo json_encode($output);
                        die();

                    }



                }
            }

            if ($json_error == "false") {


                return true;


            } else {
                return true;
                $output['code'] = 202;
                $output['msg'] = $json_error;

                echo json_encode($output);
                die();


            }
        }
    }





    public function index(){


        echo "Congratulations!. You have configured your mobile api correctly";

    }


    public function registerUser()
    {


        $this->loadModel('User');


        if ($this->request->isPost()) {


            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);



            $user['created'] = date('Y-m-d H:i:s', time());



            if(isset($data['country_id'])){

                $user['country_id'] = $data['country_id'];

            }
            if(isset($data['show_me_gender'])){


                $user['show_me_gender'] = strtolower($data['show_me_gender']);
            }
            $user['super_like_per_day'] = 1;
            $user['like_per_day'] = 30;


            if(isset($data['school'])){


                $user['school'] = $data['school'];
            }
            
             if(isset($data['school'])){


                $user['school'] = $data['school'];
            }

            if(isset($data['phone'])){


                $user['phone'] = $data['phone'];
            }

            if(isset($data['school_id'])){


                $user['school_id'] = $data['school_id'];
            }

            if(isset($data['gender'])){


                $user['gender'] = strtolower($data['gender']);
            }

            if(isset($data['gender_show'])){


                $user['gender_show'] = strtolower($data['gender_show']);
            }



            if (isset($data['image'])) {


                $image = $data['image'];
                $folder_url = UPLOADS_FOLDER_URI;

                $filePath = Utility::uploadFileintoFolder(1, $image, $folder_url);
                $user['image'] = $filePath;
            }

            if(isset($data['social']) && !isset($data['dob'])){
                $social_id = $data['social_id'];
                $auth_token = $data['auth_token'];
                $social = $data['social'];
                $user_details = $this->User->isSocialIDAlreadyExist($social_id);

                if(count($user_details) > 0 ){

                    if($social == "facebook"){

                        $verify = Utility::getFacebookUserInfo($auth_token);
                        $verify = true;
                        if($verify){

                            //$this->User->id = $user_details['User']['id'];
                            //$this->User->saveField('auth_token',$auth_token);

                            $output['code'] = 200;
                            $output['msg'] = $user_details;
                            echo json_encode($output);
                            die();

                        }else{

                            $output['code'] = 201;
                            $output['msg'] = "token invalid";
                            echo json_encode($output);
                            die();


                        }

                    }

                    if($social == "google"){

                        $verify = Utility::getGoogleUserInfo($auth_token);
                        $verify = true;
                        if($verify){

                            // $this->User->id = $user_details['User']['id'];
                            // $this->User->saveField('auth_token',$auth_token);

                            $output['code'] = 200;
                            $output['msg'] = $user_details;
                            echo json_encode($output);
                            die();

                        }else{

                            $output['code'] = 201;
                            $output['msg'] = "token invalid";
                            echo json_encode($output);
                            die();


                        }

                    }


                    $output['code'] = 200;
                    $output['msg'] = $user_details;
                    echo json_encode($output);
                    die();

                }else{


                    $output['code'] = 201;
                    $output['msg'] = "open registration screen";
                    echo json_encode($output);
                    die();

                }
            }


            if(isset($data['social']) && isset($data['dob'])){
                $social = $data['social'];
                $auth_token = $data['auth_token'];
                $user['social_id'] = $data['social_id'];
                $user['social'] = $social;
                if(isset($data['dob'])){

                    $user['dob'] = $data['dob'];
                }

                if(isset($data['username'])){

                    $user['username'] = $data['username'];
                }

                if(isset($data['gender'])){

                    $user['gender'] = strtolower($data['gender']);
                }

                if(isset($data['show_me_distance_in'])){

                    $user['show_me_distance_in'] = strtolower($data['show_me_distance_in']);
                }

                if(isset($data['first_name'])){

                    $user['first_name'] = $data['first_name'];
                    $user['last_name'] = $data['last_name'];
                }

                if(isset($data['email'])){

                    $user['email'] = $data['email'];

                }
                //$user['email'] = $data['email'];




                if($social == "facebook") {

                    $verify = Utility::getFacebookUserInfo($auth_token);
                    $verify = true;
                    if (!$verify) {


                        $output['code'] = 201;
                        $output['msg'] = "invalid Facebook token";
                        echo json_encode($output);
                        die();

                    }
                }

                if($social == "google") {

                    $verify = Utility::getGoogleUserInfo($auth_token);
                    $verify = true;
                    if (!$verify) {


                        $output['code'] = 201;
                        $output['msg'] = "invalid Google token";
                        echo json_encode($output);
                        die();

                    }
                }

                $this->User->save($user);
                $user_id = $this->User->getInsertID();

                if(isset($data['user_passion'])){
                    $user_passion_array =   $data['user_passion'];
                    $this->addUserPassion($user_passion_array,$user_id);

                }
                if(isset($data['user_sexual_orientation'])){

                    $user_sexual_orientation_array =   $data['user_sexual_orientation'];
                    $this->addUserSexualOrientation($user_sexual_orientation_array,$user_id);

                }

                if(isset($data['user_images'])){
                    $user_images = $data['user_images'];
                    $this->addNewUserImages($user_images,$user_id);
                }


                $output = array();
                $userDetails = $this->User->getUserDetailsFromID($user_id);


                $output['code'] = 200;
                $output['msg'] = $userDetails;
                echo json_encode($output);
                die();

            }

            if(!isset($data['social']) && isset($data['email']) && isset($data['dob'])){

                $session_token = Utility::generateSessionToken();
                if(isset($data['dob'])){

                    $user['dob'] = $data['dob'];
                }


                $user['auth_token'] = $session_token;

                $user['password'] = $data['password'];
                $user['email'] = $data['email'];

                if(isset($data['gender'])){

                    $user['gender'] = strtolower($data['gender']);
                }

                if(isset($data['first_name'])){

                    $user['first_name'] = $data['first_name'];
                    $user['last_name'] = $data['last_name'];
                }



              $email_count = $this->User->isEmailAlreadyExist($data['email']);



                if($email_count > 0){

                    $userData = $this->User->verify( $user['email'],  $user['password']);

                    if(count($userData) > 0){
                        $user_id = $userData[0]['User']['id'];
                        $userDetails = $this->User->getUserDetailsFromID($user_id);

                        //CustomEmail::welcomeStudentEmail($email);
                        $output['code'] = 200;
                        $output['msg'] = $userDetails;
                        echo json_encode($output);
                        die();

                    }
                    $output['code'] = 201;
                    $output['msg'] = "open login screen";
                    echo json_encode($output);
                    die();
                }


                $this->User->save($user);
                $user_id = $this->User->getInsertID();

                if(isset($data['user_passion'])){
                    $user_passion_array =   $data['user_passion'];
                    $this->addUserPassion($user_passion_array,$user_id);

                }
                if(isset($data['user_sexual_orientation'])){

                    $user_sexual_orientation_array =   $data['user_sexual_orientation'];
                    $this->addUserSexualOrientation($user_sexual_orientation_array,$user_id);

                }

                if(isset($data['user_images'])){
                    $user_images = $data['user_images'];
                    $this->addNewUserImages($user_images,$user_id);
                }

                $output = array();
                $userDetails = $this->User->getUserDetailsFromID($user_id);


                $output['code'] = 200;
                $output['msg'] = $userDetails;
                echo json_encode($output);
                die();





            }

            if(!isset($data['social']) && isset($data['email']) && !isset($data['dob'])){

                $session_token = Utility::generateSessionToken();


                $user['auth_token'] = $session_token;

                $user['password'] = $data['password'];
                $user['email'] = $data['email'];




                $userData = $this->User->verify( $user['email'],  $user['password']);


                $email_count = $this->User->isEmailAlreadyExist($data['email']);



                if($email_count < 1){

                    $output['code'] = 201;
                    $output['msg'] = "open registration screen";
                    echo json_encode($output);
                    die();
                }



            if (($userData)) {
                $user_id = $userData[0]['User']['id'];
                $session_token = Utility::generateSessionToken();
                $this->User->id = $user_id;
                $this->User->saveField('auth_token', $session_token);
                $output = array();
                $userDetails = $this->User->getUserDetailsFromID($user_id);

                //CustomEmail::welcomeStudentEmail($email);
                $output['code'] = 200;
                $output['msg'] = $userDetails;
                echo json_encode($output);


            }else{


                echo Message::INCORRECTPASSWORD();
                die();

            }


            }


            if(isset($data['phone']) && !isset($data['dob'])) {
                //login

                $user['phone'] = $data['phone'];


                $phone_exist = $this->User->isphoneNoAlreadyExist($data['phone']);

                if (count($phone_exist) > 0) {
                    $session_token = Utility::generateSessionToken();
                    $user['auth_token'] = $session_token;
                    $this->User->id = $phone_exist['User']['id'];





                    $this->User->save($user);
                    $userDetails = $this->User->getUserDetailsFromID($phone_exist['User']['id']);


                    $output['code'] = 200;
                    $output['msg'] = $userDetails;
                    echo json_encode($output);
                    die();
                } else {

                    $output['code'] = 201;
                    $output['msg'] = "open register screen";
                    echo json_encode($output);
                    die();

                }

            }else  if(isset($data['phone']) && isset($data['dob'])){

                //register
                $session_token = Utility::generateSessionToken();
                $user['phone'] = $data['phone'];
                $user['auth_token'] = $session_token;


                $user['dob'] = $data['dob'];

                if(isset($data['gender'])){

                    $user['gender'] = strtolower($data['gender']);
                }

                if(isset($data['first_name'])){

                    $user['first_name'] = $data['first_name'];
                    $user['last_name'] = $data['last_name'];
                }



                $this->User->save($user);
                $user_id = $this->User->getInsertID();


                if(isset($data['user_passion'])){
                    $user_passion_array =   $data['user_passion'];
                    $this->addUserPassion($user_passion_array,$user_id);

                }
                if(isset($data['user_sexual_orientation'])){

                    $user_sexual_orientation_array =   $data['user_sexual_orientation'];
                    $this->addUserSexualOrientation($user_sexual_orientation_array,$user_id);

                }
                if(isset($data['user_images'])){
                    $user_images = $data['user_images'];
                    $this->addNewUserImages($user_images,$user_id);
                }

                $output = array();
                $userDetails = $this->User->getUserDetailsFromID($user_id);



                $output['code'] = 200;
                $output['msg'] = $userDetails;
                echo json_encode($output);
                die();


            }











        }
    }

    public function logout()
    {


        $this->loadModel('User');

        if ($this->request->isPost()) {


            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);




            $user_id = $data['user_id'];
            $user['device_token'] = "";
            $user['online'] = 0;
            $user['auth_token'] = "";


            $userDetails = $this->User->getUserDetailsFromID($user_id);
            if(count($userDetails) > 0) {

                $this->User->id = $user_id;
                $this->User->save($user);


                $output = array();
                $userDetails = $this->User->getUserDetailsFromID($user_id);


                $output['code'] = 200;
                $output['msg'] = $userDetails;
                echo json_encode($output);
            }else{


                Message::EMPTYDATA();
                die();


            }

        }
    }

   
    public function verifyProfilePhoto(){

        $this->loadModel('UserImage');
        $this->loadModel('User');

        if ($this->request->isPost()) {




            $user_id = $this->request->data('user_id');

           $user_image_details =  $this->UserImage->getUserProfileImage($user_id);

           if(count($user_image_details) > 0) {
              $image_url =  $user_image_details['UserImage']['image'];
               if (strpos($image_url, "http") !== false) {

               }else{

                   $image_url = BASE_URL.$image_url;
               }
               $result = Utility::verifyFaceThroughDeepengin($image_url, "photo");

               if($result['code'] == 200){


                   $this->User->id = $user_id;
                   $this->User->saveField('verified',1);
                   $this->User->clear();

                   $output['code'] = 200;
                   $output['msg'] = "Profile photo has been verified";
                   echo json_encode($output);
                   die();

           }else{

                   $output['code'] = 201;
                   $output['msg'] = "not verified";
                   echo json_encode($output);
                   die();

               }



        }else{

               $output['code'] = 201;
               $output['msg'] = "image do not exist";
               echo json_encode($output);
               die();
           }

        }
    }

    public function showLicense(){


       // $if_method_exist = method_exists('Extended', 'deleteObjectS3');

        if (in_array("CoinPurchase", App::objects('Model'))) {


            $output['code'] = 200;

            $output['msg'] = "Extended";


            echo json_encode($output);

            die();
        }else{

            $output['code'] = 201;

            $output['msg'] = "Regular";


            echo json_encode($output);

            die();
        }
    }

    public function login()
    {
        $this->loadModel('User');


        if ($this->request->isPost()) {


            $json = file_get_contents('php://input');

            $data = json_decode($json, TRUE);


            $password = $data['password'];








            if (isset($data['email'])) {

                $email = strtolower($data['email']);
                $userData = $this->User->verify($email, $password);



            }


            if (($userData)) {
                $user_id = $userData[0]['User']['id'];
                $session_token = Utility::generateSessionToken();
                $this->User->id = $user_id;
                $this->User->saveField('auth_token',$session_token);
                $output = array();
                $userDetails = $this->User->getUserDetailsFromID($user_id);

                //CustomEmail::welcomeStudentEmail($email);
                $output['code'] = 200;
                $output['msg'] = $userDetails;
                echo json_encode($output);


            } else {
                echo Message::INVALIDDETAILS();
                die();

            }


        }
    }

    public function blockUser()
    {


        $this->loadModel('BlockUser');

        if ($this->request->isPost()) {


            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);


            //$user['password'] = $data['password'];


            $user_id = $data['user_id'];
            $block_user_id = $data['block_user_id'];

            $block_user['created'] = date('Y-m-d H:i:s', time());
            $block_user['user_id'] = $user_id;
            $block_user['block_user_id'] = $block_user_id;

            $userDetails = $this->BlockUser->ifAlreadyBlocked($block_user);
            if(count($userDetails) < 1) {

                $this->BlockUser->save($block_user);

                $id = $this->BlockUser->getInsertID();
                $output = array();
                $userDetails = $this->BlockUser->getDetails($id);


                $output['code'] = 200;
                $output['msg'] = $userDetails;
                echo json_encode($output);
                die();

            }else{

               $id =  $userDetails['BlockUser']['id'];
                $this->BlockUser->id = $id;
                $this->BlockUser->delete();
                $output['code'] = 201;
                $output['msg'] = "unblock";
                echo json_encode($output);
                die();

            }
        }
    }

    public function showBlockedUsers(){

        $this->loadModel('BlockUser');




        if ($this->request->isPost()) {
            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);

            $user_id = $data['user_id'];

            $details = $this->BlockUser->getBlockUsers($user_id);


            if(count($details) > 0) {


                $output['code'] = 200;

                $output['msg'] = $details;


                echo json_encode($output);


                die();
            }else{


                Message::EMPTYDATA();
                die();
            }

        }


    }


    public function showCountries(){

        $this->loadModel('Country');




        if ($this->request->isPost()) {
            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);



            $countries = $this->Country->getAll();





            $output['code'] = 200;

            $output['msg'] = $countries;


            echo json_encode($output);


            die();


        }


    }


    public function showDefaultCurrency(){

        $this->loadModel('Country');




        if ($this->request->isPost()) {
            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);



            $countries = $this->Country->getDefaultCountry();





            $output['code'] = 200;

            $output['msg'] = $countries;


            echo json_encode($output);


            die();


        }


    }

    public function editProfile()
    {


        $this->loadModel('User');

        if ($this->request->isPost()) {


            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);








            $user_id = $data['user_id'];





            if(isset($data['first_name'])){


                $user['first_name'] = $data['first_name'];
            }
            if(isset($data['last_name'])){


                $user['last_name'] = $data['last_name'];
            }

            if(isset($data['bio'])){


                $user['bio'] = $data['bio'];
            }

            if(isset($data['show_me_distance_in'])){

                $user['show_me_distance_in'] = strtolower($data['show_me_distance_in']);
            }
            if(isset($data['show_me'])){


                $user['show_me'] = $data['show_me'];
            }

            if(isset($data['min_age'])){


                $user['min_age'] = $data['min_age'];
            }

            if(isset($data['max_age'])){


                $user['max_age'] = $data['max_age'];
            }


            if(isset($data['gender'])){


                $user['gender'] = strtolower($data['gender']);
            }

            if(isset($data['phone'])){


                $user['phone'] = $data['phone'];
            }

            if(isset($data['show_me_gender'])){


                $user['show_me_gender'] = strtolower($data['show_me_gender']);
            }

            if(isset($data['radius'])){


                $user['radius'] = $data['radius'];
            }

            if(isset($data['country_id'])){


                $user['country_id'] = $data['country_id'];
            }


            if(isset($data['job_title'])){


                $user['job_title'] = $data['job_title'];
            }

            if(isset($data['company'])){


                $user['company'] = $data['company'];
            }
           
            if(isset($data['school_id'])){


                $user['school_id'] = $data['school_id'];
            }
            
             if(isset($data['school'])){


                $user['school'] = $data['school'];
                 $user['school_id'] = 0;
            }
            if(isset($data['dob'])){


                $user['dob'] = $data['dob'];
            }
            if(isset($data['hide_me'])){


                $user['hide_me'] = $data['hide_me'];
            }
            if(isset($data['hide_age'])){


                $user['hide_age'] = $data['hide_age'];
            }

            if(isset($data['hide_location'])){


                $user['hide_location'] = $data['hide_location'];
            }

            if(isset($data['email'])){


                if($data['email'] == "rider@gmail.com" || $data['email'] == "user@gmail.com" && APP_STATUS == "demo"){

                    $output['code'] = 201;
                    $output['msg'] = "You cannot change demo account information";
                    echo json_encode($output);
                    die();
                }
                $user['email'] = $data['email'];
                $email_exist = $this->User->editIsEmailAlreadyExist($data['email'], $user_id);



                if($email_exist > 0){

                    $output['code'] = 201;
                    $output['msg'] = "email already exist";
                    echo json_encode($output);
                    die();
                }
            }

            if(isset($data['user_passion'])){
                $user_passion_array =   $data['user_passion'];
                $this->addUserPassion($user_passion_array,$user_id,1);

            }



            // $phone = $this->User->editIsphoneNoAlreadyExist($data['phone'], $user_id);


            $this->User->id = $user_id;
            $this->User->save($user);


            $output = array();
            $userDetails = $this->User->getUserDetailsFromID($user_id);


            $output['code'] = 200;
            $output['msg'] = $userDetails;
            echo json_encode($output);


        }
    }
    public function addDeviceData()
    {


        $this->loadModel('User');

        if ($this->request->isPost()) {


            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);

            $user['device_token'] = $data['device_token'];
            $user['ip'] = $data['ip'];
            $user['device'] = $data['device'];
            $user['version'] = $data['version'];
            $user['lat'] = $data['lat'];
            $user['long'] = $data['long'];
            $user_id = $data['user_id'];


            $userDetails = $this->User->getUserDetailsFromID($user_id);
            if(count($userDetails) > 0) {

                $this->User->id = $user_id;
                $this->User->save($user);

                $output = array();
                $userDetails = $this->User->getUserDetailsFromID($user_id);


                $output['code'] = 200;
                $output['msg'] = $userDetails;
                echo json_encode($output);
            }else{


                Message::EMPTYDATA();
                die();


            }

        }
    }



    public function addUserImage()
    {


        $this->loadModel('User');
        $this->loadModel('UserImage');


        if ($this->request->isPost()) {


            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);

            $user_id = $data['user_id'];


            $userDetails = $this->User->getUserDetailsFromID($user_id);

            if(count($userDetails) > 0) {




                    if(isset($data['id'])){
                       $id =  $data['id'];
                        $details = $this->UserImage->getDetails($id);
                       $image_db = $details['UserImage']['image'];

                    if (strlen($image_db) > 5) {
                       @unlink($image_db);

                   }

                        $image = $data['image'];
                        $folder_url = UPLOADS_FOLDER_URI;

                        $filePath = Utility::uploadFileintoFolderDir($image, $folder_url);

                        $user_image['image'] = $filePath;
                        $user_image['order_sequence'] = $data['order_sequence'];
                        $this->UserImage->id;
                        $this->UserImage->save($user_image);

                    }else if (isset($data['image'])) {

                        $image = $data['image'];
                        $folder_url = UPLOADS_FOLDER_URI;

                        $filePath = Utility::uploadFileintoFolderDir($image, $folder_url);
                        $user_image['image'] = $filePath;
                        $user_image['user_id'] = $user_id;
                        $user_image['order_sequence'] = $data['order_sequence_single'];
                        $user_image['created'] = date('Y-m-d H:i:s', time());


                        $this->UserImage->save($user_image);
                        $id = $this->UserImage->getInsertID();
                        }


                if (isset($data['sequence'])){

                    $sequence = $data['sequence'];
                        foreach ($sequence as $seq){

                            $id = $seq['id'];
                            $order_sequence = $seq['order_sequence'];
                            $this->UserImage->id = $id;
                            $this->UserImage->saveField('order_sequence',$order_sequence);
                            $this->UserImage->clear();
                        }
                    }


                    $details = $this->UserImage->getDetails($id);

                    $output = array();


                    $output['code'] = 200;
                    $output['msg'] = $details;
                    echo json_encode($output);



            }else {


                Message::EMPTYDATA();
                die();

            }

        }
    }

    public function addNewUserImages($images,$user_id)
    {


        $this->loadModel('User');
        $this->loadModel('UserImage');






            $userDetails = $this->User->getUserDetailsFromID($user_id);

            if(count($userDetails) > 0) {






                    $folder_url = UPLOADS_FOLDER_URI;
                    foreach ($images as $key=>$val) {

                        $image = $val['image'];
                        $order_sequence = $val['order_sequence'];
                        $filePath = Utility::uploadFileintoFolderDir($image, $folder_url);
                        $user_image[$key]['image'] = $filePath;
                        $user_image[$key]['user_id'] = $user_id;
                        $user_image[$key]['order_sequence'] = $order_sequence;
                        $user_image[$key]['created'] = date('Y-m-d H:i:s', time());





                }

                $this->UserImage->saveAll($user_image);




              return true;

            }else {


                Message::EMPTYDATA();
                die();

            }


    }

    public function deleteUserImage()
    {


        $this->loadModel('User');
        $this->loadModel('UserImage');


        if ($this->request->isPost()) {


            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);

            $id = $data['id'];

            $details = $this->UserImage->getDetails($id);
            if(count($details) > 0) {



                    $details = $this->UserImage->getDetails($id);
                    $image_db = $details['UserImage']['image'];

                    if (strlen($image_db) > 5) {
                        @unlink($image_db);

                    }
                    $this->UserImage->id = $id;
                    $this->UserImage->delete();


                    $output['code'] = 200;
                    $output['msg'] = "success";
                    echo json_encode($output);



            }
        }
    }


    public function deleteInbox()
    {


        $this->loadModel('User');
        $this->loadModel('Inbox');


        if ($this->request->isPost()) {


            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);

            $sender_id = $data['sender_id'];
            $receiver_id = $data['receiver_id'];

            $inbox_details = $this->Inbox->ifInboxExist($sender_id,$receiver_id);

            if(count($inbox_details) > 0){


                $this->Inbox->id = $inbox_details['Inbox']['id'];
                $this->Inbox->delete();

                $output['code'] = 200;
                $output['msg'] = "success";
                echo json_encode($output);


                die();
            }else{

                Message::EMPTYDATA();
                die();

            }


        }
    }
    public function deleteUserAccount()
    {


        $this->loadModel('User');



        if ($this->request->isPost()) {


            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);

            $user_id = $data['user_id'];

            $user_details = $this->User->getUserDetailsFromID($user_id);

            if(count($user_details) > 0){


                $this->User->id = $user_id;
                $this->User->delete($user_id,true);
/*

                $this->User->id = $user_id;

                $details = $this->UserImage->getDetails($id);
                $image_db = $details['UserImage']['image'];

                if (strlen($image_db) > 5) {
                    @unlink($image_db);

                }
                $this->UserImage->id = $id;
                $this->UserImage->delete();
*/

                $output['code'] = 200;
                $output['msg'] = "success";
                echo json_encode($output);


                die();
            }else{


                $output['code'] = 201;
                $output['msg'] = "error";
                echo json_encode($output);

            }
        }
    }



   
    
    
    public function showNearByUsers()
    {

        $this->loadModel("User");
        $this->loadModel("LikeUser");
        $this->loadModel("BlockUser");



        if ($this->request->isPost()) {

            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);

            $user_id = $data['user_id'];
            
            $lat = $data['lat'];
            $long = $data['long'];
            $starting_point = $data['starting_point'];


            $user_details = $this->User->getUserDetailsFromID($user_id);

    


            $users_new = array();
            if(count($user_details) > 0){

                $gender = $user_details['User']['show_me_gender'];
                $this->User->id = $user_details['User']['id'];
                $this->User->saveField('last_seen',date('Y-m-d H:i:s', time()));


                $users = $this->User->getNearByUsers($lat,$long,$user_id,$user_details['User']['radius'],$gender,$starting_point);
               
              
                $boosted_profiles = $this->User->getBoostedProfiles();




                if(count($boosted_profiles) > 0){

                    foreach($boosted_profiles as $boosted) {

                        $boost_user_id = $boosted['User']['id'];
                        $boost_datetime = $boosted['User']['boost_datetime'];
                        $current_datetime = date('Y-m-d H:i:s', time());
                        $minutes = (strtotime($current_datetime) - strtotime($boost_datetime));
                        if ($minutes > 1800) {

                            $this->User->id = $boost_user_id;
                            $this->User->saveField('boost', 0);
                            $this->User->clear();
                        }

                    }

                }



                        //$if_liked_1 = $this->LikeUser->IfUserHasSwipedLiked($user_id, $other_user_id);
                         //$if_liked_2 = $this->LikeUser->IfUserHasSwipedLiked($other_user_id, $user_id);
                        //$if_super_liked = $this->LikeUser->IfUserHasSwipedSuperLiked($user['User']['id'], $user_id);



                    
              

                if(count($users) > 0) {
                    $output['code'] = 200;

                    $output['msg'] = $users;


                    echo json_encode($output);


                    die();
                }else{

                    Message::EMPTYDATA();
                    die();

                }
           
            }
        }
    }


    public function useCoin(){




        $this->loadModel("CoinPurchase");
        $this->loadModel("User");




        if ($this->request->isPost()) {
            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);

            $user_id = $data['user_id'];
            $coin = $data['coin'];
            $feature = $data['feature'];


            $created = date('Y-m-d H:i:s', time());


            $user_details = $this->User->getUserDetailsFromID($data['user_id']);
            if(count($user_details) > 0) {

                $wallet = $user_details['User']['wallet'];
                $total_boost = $user_details['User']['total_boost'];
                $total_superlike = $user_details['User']['total_superlike'];

                if($feature == "boost"){



                    $user_data['total_boost'] = 1 + $total_boost;
                    $user_data['wallet'] = $wallet - $coin;


                }else if($feature == "superlike"){


                    $user_data['total_superlike'] = 1 + $total_superlike;
                    $user_data['wallet'] = $wallet - $coin;
                }

                if(count($user_data) > 0) {
                    $this->User->id = $user_id;
                    $this->User->save($user_data);

                }


            }



            $user_details = $this->User->getUserDetailsFromID($data['user_id']);




            $output['code'] = 200;
            $output['msg'] = $user_details;
            echo json_encode($output);
            die();

        }
    }


    public function purchaseCoin(){




        $this->loadModel("CoinPurchase");
        $this->loadModel("User");




        if ($this->request->isPost()) {
            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);

            $purchase['user_id'] = $data['user_id'];
            $purchase['title'] = $data['title'];
            $purchase['coin'] = $data['coin'];
            $purchase['price'] = $data['price'];
            $purchase['purchase_id'] = $data['purchase_id'];

            $purchase['created'] = date('Y-m-d H:i:s', time());














            $this->CoinPurchase->save($purchase);

            $id = $this->CoinPurchase->getInsertID();
            //$subscription_detail = $this->PurchaseCoin->getDetails($id);

            $user_details = $this->User->getUserDetailsFromID($data['user_id']);
            if(count($user_details) > 0){

                $wallet = $user_details['User']['wallet'];
                /*$total_boost =  $user_details['User']['total_boost'];
                $total_super_like =  $user_details['User']['total_super_like_per_day'];
                $total_like =  $user_details['User']['total_like_per_day'];
                $user['total_boost'] = $total_boost + 1;
                $user['total_like_per_day'] = $total_like + 10000;
                $user['total_super_like_per_day'] = $total_super_like + 5;*/


                $this->User->id = $user_details['User']['id'];
                $this->User->saveField('wallet',$wallet + $data['coin']);

            }
            $user_details = $this->User->getUserDetailsFromID($data['user_id']);
            $output['code'] = 200;
            $output['msg'] = $user_details;
            echo json_encode($output);
            die();

        }
    }



    public function startSubscription(){




        $this->loadModel("SubscriptionPackage");
        $this->loadModel("User");




        if ($this->request->isPost()) {
            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);

            $purchase['user_id'] = $data['user_id'];
            $purchase['package'] = $data['package'];
            $purchase['amount'] = $data['amount'];
            $purchase['duration'] = $data['duration'];
            $purchase['active'] = 1;
            $purchase['created'] = date('Y-m-d H:i:s', time());




            $subscription_detail = $this->SubscriptionPackage->ifUserHasAlreadySubscribed($data['user_id']);

            if(count($subscription_detail) > 0) {




                $this->SubscriptionPackage->id = $subscription_detail['SubscriptionPackage']['id'];
                $this->SubscriptionPackage->delete();


            }




                $this->SubscriptionPackage->save($purchase);
                $this->User->id = $user_details['User']['id'];
                $this->User->saveField("paid",1);
                $this->User->clear();
                $id = $this->SubscriptionPackage->getInsertID();
                $subscription_detail = $this->SubscriptionPackage->getDetails($id);

            $user_details = $this->User->getUserDetailsFromID($data['user_id']);
            if(count($user_details) > 0){

               $total_boost =  $user_details['User']['total_boost'];
               $total_super_like =  $user_details['User']['total_superlike'];
               $total_like =  $user_details['User']['total_like_per_day'];
               $user['total_boost'] = $total_boost + 1;
               $user['total_like_per_day'] = $total_like + 10000;
               $user['total_super_like_per_day'] = $total_super_like + 5;


                $this->User->id = $user_details['User']['id'];
                $this->User->save($user);

            }

                $output['code'] = 200;
                $output['msg'] = $subscription_detail;
                echo json_encode($output);
                die();

        }
    }


    public function endSubscription(){




        $this->loadModel("SubscriptionPackage");




        if ($this->request->isPost()) {
            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);

            $purchase['user_id'] = $data['user_id'];
            $purchase['package'] = $data['package'];





            $subscription_detail = $this->SubscriptionPackage->ifUserHasAlreadySubscribeThisPackage($data['user_id'],$data['package']);

            if(count($subscription_detail) > 0) {




                $this->SubscriptionPackage->id = $subscription_detail['SubscriptionPackage']['id'];
                $this->SubscriptionPackage->delete();

                $output['code'] = 200;
                $output['msg'] = "deleted";
                echo json_encode($output);
                die();

            }


        }
    }
    public function boostPurchase(){




        $this->loadModel("BoostPurchase");




        if ($this->request->isPost()) {
            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);

            $purchase['user_id'] = $data['user_id'];
            $purchase['no_of_boost'] = $data['no_of_boost'];
            $purchase['transaction_id'] = $data['transaction_id'];
            $purchase['created'] = date('Y-m-d H:i:s', time());




            $user_detail = $this->User->getUserDetailsFromID($data['user_id']);

            if(count($user_detail) > 0) {


                $total_boost = $user_detail['User']['total_boost'];



              $this->User->id = $user_detail['User']['id'];
              $this->User->saveField('total_boost',$total_boost + $purchase['no_of_boost']);

              $this->BoostPurchase->save($purchase);


                $id = $this->BoostPurchase->getInsertID();
                $this->BoostPurchase->getDetails($id);

                $user_detail = $this->User->getUserDetailsFromID($data['user_id']);

                $output['code'] = 200;
                $output['msg'] = $user_detail;
                echo json_encode($output);
                die();
            }
        }
    }

    public function boostProfile(){




        $this->loadModel("User");




        if ($this->request->isPost()) {
            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);

            $user_id = $data['user_id'];

            $created = date('Y-m-d H:i:s', time());




            $user_detail = $this->User->getUserDetailsFromID($user_id);

            if(count($user_detail) > 0) {


                $total_boost = $user_detail['User']['total_boost'];

                if ($total_boost > 0) {

                    $boost_data['boost'] = 1;
                    $boost_data['boost_datetime'] = $created;
                    $this->User->id = $user_detail['User']['id'];
                    $this->User->save($boost_data);
                }else{


                    $output['code'] = 201;
                    $output['msg'] = "You need to subscribe first";
                    echo json_encode($output);
                    die();
                }


                $user_detail = $this->User->getUserDetailsFromID($user_id);

                $output['code'] = 200;
                $output['msg'] = $user_detail;
                echo json_encode($output);
                die();
            }
        }
    }


    public function matchUser(){



        $this->loadModel("LikeUser");
        $this->loadModel("User");
        $this->loadModel("Match");



        if ($this->request->isPost()) {
            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);

            $user_id = $data['user_id'];
            $other_user_id = $data['other_user_id'];

            $created = date('Y-m-d H:i:s', time());
            $match['user_id'] = $user_id;
            $match['other_user_id'] = $other_user_id;
            $match['created'] = $created;

            $other_user_detail = $this->User->getUserDetailsFromID($other_user_id);
            $user_detail = $this->User->getUserDetailsFromID($user_id);

            $if_duplicate = $this->Match->checkDuplicate($user_id,$other_user_id);

            if(count($if_duplicate) > 0){
                $if_user_liked =  $this->LikeUser->IfUserHasSwiped($other_user_id,$user_id);
                $if_other_liked =  $this->LikeUser->IfUserHasSwiped($user_id,$other_user_id);

                if(count($if_user_liked) > 0){


                    $this->LikeUser->id = $if_user_liked['LikeUser']['id'];
                    $this->LikeUser->delete();
                    $this->LikeUser->clear();
                    $output['code'] = 201;
                    $output['msg'] = "already matched";
                    echo json_encode($output);
                    die();
                }

                if(count($if_other_liked) > 0){


                    $this->LikeUser->id = $if_other_liked['LikeUser']['id'];
                    $this->LikeUser->delete();
                    $this->LikeUser->clear();
                }
                $output['code'] = 201;
                $output['msg'] = "already matched";
                echo json_encode($output);
                die();
            }
            $notification['to'] = $other_user_detail['User']['device_token'];
            $notification['notification']['title'] = "Congratulations";
            $notification['notification']['body'] = "You have 1 new match";
            $notification['notification']['user_id'] = $user_detail['User']['id'];
            $notification['notification']['image'] = $user_detail['User']['image'];
            $notification['notification']['name'] = $user_detail['User']['first_name'];
            $notification['notification']['badge'] = "1";
            $notification['notification']['sound'] = "default";
            $notification['notification']['icon'] = "";
            $notification['notification']['type'] = "match";

            $notification['data']['title'] = "Congratulation";
            $notification['data']['name'] = $user_detail['User']['first_name'];
            $notification['data']['body'] = "You have 1 new match";
            $notification['data']['icon'] = "";
            $notification['data']['badge'] = "1";
            $notification['data']['sound'] = "default";
            $notification['data']['type'] = "match";
            $notification['data']['user_id'] = $user_detail['User']['id'];
            $notification['data']['image'] = $user_detail['User']['image'];
            $result = Utility::sendPushNotificationToMobileDevice(json_encode($notification));


            $this->Match->save($match);
            $id = $this->Match->getInsertID();
            $details = $this->Match->getDetails($id);

            $if_user_liked =  $this->LikeUser->IfUserHasSwiped($other_user_id,$user_id);
            $if_other_liked =  $this->LikeUser->IfUserHasSwiped($user_id,$other_user_id);


            if(count($if_user_liked) > 0){


                $this->LikeUser->id = $if_user_liked['LikeUser']['id'];
                $this->LikeUser->delete();
                $this->LikeUser->clear();
               
            }

            if(count($if_other_liked) > 0){


                $this->LikeUser->id = $if_other_liked['LikeUser']['id'];
                $this->LikeUser->delete();
                $this->LikeUser->clear();
            }

            $output['code'] = 200;
            $output['msg'] = $details;
            echo json_encode($output);
            die();

        }
    }

    public function reportUser()
    {


        $this->loadModel("ReportUser");
        $this->loadModel("User");
        $this->loadModel("ReportReason");
        $this->loadModel("Inbox");




        if ($this->request->isPost()) {
            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);


            $report_user_id = $data['report_user_id'];
            $user_id = $data['user_id'];
            $report_reason_id = $data['report_reason_id'];
            $description = $data['description'];
            $created = date('Y-m-d H:i:s', time());


            $report['report_user_id'] = $report_user_id;
            $report['user_id'] = $user_id;
            $report['report_reason_id'] = $report_reason_id;
            $report['description'] = $description;
            $report['created'] = $created;


            $details = $this->User->getUserDetailsFromID($report_user_id);


            $report_reason_details =  $this->ReportReason->getDetails($report_reason_id);




            if (count($details) > 0) {

                if(count($report_reason_details) > 0){

                    $report['report_reason_title'] = $report_reason_details['ReportReason']['title'];

                }
                $this->ReportUser->save($report);



                $sender_id = $user_id;
                $receiver_id = $report_user_id;

                $inbox_details = $this->Inbox->ifInboxExist($sender_id,$receiver_id);

                if(count($inbox_details) > 0) {


                    $this->Inbox->id = $inbox_details['Inbox']['id'];
                    $this->Inbox->delete();


                }


                $id = $this->ReportUser->getInsertID();
                $details = $this->ReportUser->getDetails($id);


                $output['code'] = 200;
                $output['msg'] = $details;
                echo json_encode($output);


                die();
            }else{

                $output['code'] = 201;
                $output['msg'] = "user not available";
                echo json_encode($output);


                die();
            }


        }
    }

    public function showReportReasons(){

        $this->loadModel('ReportReason');




        if ($this->request->isPost()) {
            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);



            $details = $this->ReportReason->getAll();


            if(count($details) > 0) {


                $output['code'] = 200;

                $output['msg'] = $details;


                echo json_encode($output);


                die();
            }else{


                Message::EMPTYDATA();
                die();
            }

        }


    }

    public function likeUser()
    {

        $this->loadModel("LikeUser");
        $this->loadModel("Setting");
        $this->loadModel("User");



        if ($this->request->isPost()) {
            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);



            $created = date('Y-m-d H:i:s', time());
            $date = date('Y-m-d', time());


            $details = $this->Setting->getAll();
            if(count($details) > 0){

                $like_per_day = $details['Setting']['likes_per_day'];
                $super_like_per_day = $details['Setting']['super_likes_per_day'];

            }else{

                //default values limit
                $like_per_day = 1000000000;
                $super_like_per_day = 10000000;

            }


                $like_data = $data['like_data'];
            $i = 0;
                foreach ($like_data as $key=>$like_val){
                    $user_details = $this->User->getUserDetailsFromID($like_val['user_id']);
                   // $total_superlike = $user_details['User']['total_superlike'];
                    $ifswiped = $this->LikeUser->IfUserHasSwiped($like_val['user_id'],$like_val['other_user_id']);
                    if(count($ifswiped) > 0 ){

                        $this->LikeUser->id = $ifswiped['LikeUser']['id'];
                        $this->LikeUser->delete();
                    }

                    $count_swipes = $this->LikeUser->getUserSwipedInADay($like_val['user_id'],$date);
                    if($count_swipes > $like_per_day &&  $like_val['super_like'] < 1){


                        $output['code'] = 201;
                        $output['msg'] = "like limit reached per day. please subscribe for unlimited likes";
                        echo json_encode($output);


                        die();
                    }


                    $if_other_person_liked_you = $this->LikeUser->IfUserHasSwiped($like_val['other_user_id'],$like_val['user_id']);


                    if(count($if_other_person_liked_you) > 0 ){

                        $this->LikeUser->id = $if_other_person_liked_you['LikeUser']['id'];
                        $this->LikeUser->delete();
                    }else{

                        $like_save[$i]['user_id'] = $like_val['user_id'];
                        $like_save[$i]['other_user_id'] = $like_val['other_user_id'];
                        $like_save[$i]['like'] = $like_val['like'];
                        $like_save[$i]['super_like'] = $like_val['super_like'];
                        $like_save[$i]['created'] = $created;
                        $i++;

                    }





                    $count_super_swipes = $this->LikeUser->getUserSuperLikeSwipedInADay($like_val['user_id'],$date);
                    if($count_super_swipes > $super_like_per_day &&  $like_val['super_like'] > 0){
                        $userDetail = $this->User->getUserDetailsFromID($like_val['user_id']);
                       $user_wallet =  $userDetail['User']['wallet'];

                       if($user_wallet >= 50){

                           $this->User->id = $like_val['user_id'];
                           $this->User->saveField('wallet',$user_wallet - 50);
                           $this->User->clear();

                       }else {
                           unset($like_save[$key]);
                           $key = $key-1;

                          /* $output['code'] = 201;
                           $output['msg'] = "super like limit reached per day. please subscribe";
                           echo json_encode($output);


                           die();*/
                       }
                    }

                }

                if(count($like_save) > 0) {

                    $this->LikeUser->saveAll($like_save);

                }else{


                    $output['code'] = 201;
                    $output['msg'] = "like limit reached per day. please subscribe";
                    echo json_encode($output);


                    die();
                }




            $output['code'] = 200;
            $output['msg'] = "success";
            echo json_encode($output);


            die();

        }
    }


    public function likeUserNew()
    {

        $this->loadModel("LikeUser");
        $this->loadModel("Setting");
        $this->loadModel("User");



        if ($this->request->isPost()) {
            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);



            $created = date('Y-m-d H:i:s', time());
            $date = date('Y-m-d', time());
            $user_id = $data['user_id'];
              $other_user_id = $data['other_user_id'];
                 $like = $data['like'];
                  $super_like = $data['super_like'];


            $details = $this->Setting->getAll();
            if(count($details) > 0){

                $like_per_day = $details['Setting']['likes_per_day'];
                $super_like_per_day = $details['Setting']['super_likes_per_day'];

            }else{

                //default values limit
                $like_per_day = 1000000000;
                $super_like_per_day = 10000000;

            }

              $user_detail = $this->User->getUserDetailsFromID($user_id);
               $other_user_detail = $this->User->getUserDetailsFromID($other_user_id);
                
                 $msg = "success";
                  
                 if($like > 0 || $super_like > 0){
                     
                     
                      $ifswiped_2 = $this->LikeUser->IfUserHasSwipedLiked($other_user_id,$user_id);
                        $if_super_liked = $this->LikeUser->IfUserHasSwipedSuperLiked($other_user_id,$user_id);
                      
                      if(count($ifswiped_2) > 0 || count($if_super_liked) > 0){
                          
                          
                           $notification['to'] = $other_user_detail['User']['device_token'];
                            $notification['notification']['title'] = "Congratulations";
                            $notification['notification']['body'] = "You have 1 new match";
                            $notification['notification']['user_id'] = $user_detail['User']['id'];
                            $notification['notification']['image'] = $user_detail['User']['image'];
                            $notification['notification']['name'] = $user_detail['User']['first_name'];
                            $notification['notification']['badge'] = "1";
                            $notification['notification']['sound'] = "default";
                            $notification['notification']['icon'] = "";
                            $notification['notification']['type'] = "match";
                
                            $notification['data']['title'] = "Congratulation";
                            $notification['data']['name'] = $user_detail['User']['first_name'];
                            $notification['data']['body'] = "You have 1 new match";
                            $notification['data']['icon'] = "";
                            $notification['data']['badge'] = "1";
                            $notification['data']['sound'] = "default";
                            $notification['data']['type'] = "match";
                            $notification['data']['user_id'] = $user_detail['User']['id'];
                            $notification['data']['image'] = $user_detail['User']['image'];
                            $result = Utility::sendPushNotificationToMobileDevice(json_encode($notification));
                            $msg = $other_user_detail;

                          
                      }
                 }


                        $like_save['user_id'] = $user_id;
                        $like_save['other_user_id'] = $other_user_id;
                        $like_save['like'] = $like;
                        $like_save['super_like'] = $super_like;
                        $like_save['created'] = $created;

                $this->LikeUser->save($like_save);

            $output['code'] = 200;
            $output['msg'] = $msg;
           
            echo json_encode($output);


            die();

        }
    }


    public function showSchools()
    {

        $this->loadModel("School");





        if ($this->request->isPost()) {


            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);
            $keyword = $data['keyword'];



            $details = $this->School->getSearchResults($keyword);
            if(count($details) > 0){


                $output['code'] = 200;

                $output['msg'] = $details;
                echo json_encode($output);


                die();

            }else{

                Message::EMPTYDATA();
                die();
            }



        }
    }
    public function showPassions()
    {

        $this->loadModel("Passion");





        if ($this->request->isPost()) {


            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);



            $details = $this->Passion->getAll();
            if(count($details) > 0){


                $output['code'] = 200;

                $output['msg'] = $details;
                echo json_encode($output);


                die();

            }else{

                Message::EMPTYDATA();
                die();
            }



        }
    }



    function addUserPassion($passion_array,$user_id,$edit = null){


        $this->loadModel("UserPassion");

                if(is_null($edit)){


                }else{

                    $this->UserPassion->deletePassions($user_id);

                }



            foreach ($passion_array as $key=>$val){

                $details[$key]['passion_id'] = $val['passion_id'];
                $details[$key]['user_id'] = $user_id;

        }
        if(count($passion_array) > 0) {
            $this->UserPassion->saveAll($details);

        }

        return true;

    }

    function addUserSexualOrientation($sexual_orientation_array,$user_id){


        $this->loadModel("UserSexualOrientation");




        foreach ($sexual_orientation_array as $key=>$val){

            $details[$key]['sexual_orientation_id'] = $val['sexual_orientation_id'];
            $details[$key]['user_id'] = $user_id;

        }

        if(count($sexual_orientation_array) > 0) {
            $this->UserSexualOrientation->saveAll($details);
        }
        return true;

    }

    public function showSexualOrientation()
    {

        $this->loadModel("SexualOrientation");





        if ($this->request->isPost()) {


            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);



            $details = $this->SexualOrientation->getAll();
            if(count($details) > 0){


                $output['code'] = 200;

                $output['msg'] = $details;
                echo json_encode($output);


                die();

            }else{

                Message::EMPTYDATA();
                die();
            }



        }
    }


    public function showUserDetail()
    {

        $this->loadModel("User");
        $this->loadModel("CoinUsed");
        $this->loadModel("SubscriptionPackage");
        if (in_array("CoinPurchase", App::objects('Model'))) {


            $this->loadModel("CoinPurchase");
        }




        if ($this->request->isPost()) {


            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);

            $user_id = $data['user_id'];


            $userDetail = $this->User->getUserDetailsFromID($user_id);

            $subscription_detail = $this->SubscriptionPackage->ifUserHasAlreadySubscribed($data['user_id']);

            $userDetail['User']['subscribe'] = 0;
            if(count($subscription_detail) > 0) {

                $userDetail['User']['subscribe'] = 1;
            }

                $output['code'] = 200;

            $output['msg'] = $userDetail;
            echo json_encode($output);


            die();
        }
    }


    public function fakeEntry()
    {

        $this->loadModel("User");
        $this->loadModel("Userfake");
        $this->loadModel("UserImage");
        $this->loadModel("UserImagefake");
        $this->loadModel("Fakename");








            $fake_users = $this->Userfake->getfakeUsers();


            if(count($fake_users) > 0){


                foreach($fake_users as $fake_user){


                   $post_data['lat'] =  $fake_user['Userfake']['lat'];
                   $post_data['long'] =  $fake_user['Userfake']['long'];
                   $post_data['created'] =  date('Y-m-d H:i:s', time());
                   $post_data['gender'] =  $fake_user['Userfake']['gender'];
                   $post_data['bio'] =  $fake_user['Userfake']['bio'];
                   $post_data['email'] =  $fake_user['Userfake']['email'];
                   $post_data['active'] =  1;
                   $post_data['fake'] =  1;

                    $fake_name_detail = $this->Fakename->getfakename($fake_user['Userfake']['gender']);


                    if(count($fake_name_detail) > 0){

                        $post_data['first_name'] =  $fake_name_detail['Fakename']['givenname'];




                        $user_images = $this->UserImagefake->getUserImages($fake_user['Userfake']['id']);


                        if(count($user_images) > 0){

                            $this->Fakename->id = $fake_name_detail['Fakename']['id'];
                            $this->Fakename->saveField('done',1);
                            $this->Fakename->clear();
                            $this->User->save($post_data);
                            $user_id = $this->User->getInsertID();
                            $this->User->clear();
                            $i = 0;
                            foreach($user_images as $key=>$val){


                                $post_image[$i]['image']  = $val['UserImagefake']['image'];
                                $post_image[$i]['order_sequence'] = $val['UserImagefake']['order_sequence'];
                                $post_image[$i]['user_id'] = $user_id;
                                 $i++;
                            }

                            $this->UserImage->saveAll($post_image);
                            $this->UserImage->clear();

                        echo $user_id."<br>";


                        $this->Userfake->id = $fake_user['Userfake']['id'];
                        $this->Userfake->saveField('done',1);
                            $this->Userfake->clear();



                        }






                    }else{


                        echo "empty";
                        die();
                    }







                }
            }



            $output['code'] = 200;

            $output['msg'] = "success";
            echo json_encode($output);


            die();
        }

    public function showUserLikes()
    {

        $this->loadModel("LikeUser");





        if ($this->request->isPost()) {


            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);

            $user_id = $data['user_id'];


            $userDetail = $this->LikeUser->getThoseUsersWhoLikedThisUser($user_id);



            $output['code'] = 200;

            $output['msg'] = $userDetail;
            echo json_encode($output);


            die();
        }
    }
    public function showUserMatches()
    {

        $this->loadModel("Match");
        $this->loadModel("Inbox");
        $this->loadModel("LikeUser");





        if ($this->request->isPost()) {


            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);

            $user_id = $data['user_id'];


            $userDetail = $this->Match->getMatches($user_id);
            $inbox_detail = $this->Inbox->getInbox($user_id);
            $like_count = $this->LikeUser->getCountThoseUsersWhoLikedThisUser($user_id);
            $first_like_user = $this->LikeUser->getSingleUserWhoLikedThisUser($user_id);


            $output['code'] = 200;

            $output['msg']['matches'] = $userDetail;
            $output['msg']['inbox'] = $inbox_detail;
            $output['msg']['like_users_count'] = $like_count;
            $output['msg']['like_user'] = $first_like_user;
            echo json_encode($output);


            die();
        }
    }

    public function deleteMatch()
    {

        $this->loadModel("Match");





        if ($this->request->isPost()) {


            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);

            $user_id = $data['user_id'];
            $other_user_id = $data['other_user_id'];

            $match_details = $this->Match->checkDuplicate($user_id,$other_user_id);

            if(count($match_details) > 0){



                $this->Match->id = $match_details['Match']['id'];
                $this->Match->delete();

                $match_details = $this->Match->checkDuplicate($user_id,$other_user_id);
                if(count($match_details) > 0){


                    $this->Match->id = $match_details['Match']['id'];
                    $this->Match->delete();

                }


            }









            $output['code'] = 200;

            $output['msg'] = "deleted";
            echo json_encode($output);


            die();
        }
    }


    public function addUserLatLong(){


        $this->loadModel('User');



        if ($this->request->isPost()) {
            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);

            //$trip['trip_id'] =

            $loc['lat'] = $data['lat'];
            $loc['long'] = $data['long'];

            $user_id =  $data['user_id'];
                $details = $this->User->getUserDetailsFromID($user_id);

                if(count($details) > 0) {
                    $this->User->id = $user_id;
                    $this->User->save($loc);
                    $user_details =  $this->User->getUserDetailsFromID($user_id);

                    $output['code'] = 200;

                    $output['msg'] = $user_details;


                    echo json_encode($output);


                    die();

                }else{

                    Message::EMPTYDATA();
                    die();
                }




        }




    }



    function forgotPassword()
    {


        $this->loadModel('User');

        if ($this->request->isPost()) {


            $result = array();
            $json   = file_get_contents('php://input');

            $data = json_decode($json, TRUE);


            $email     = $data['email'];



            $code     = Utility::randomNumber(4);
            $user_info = $this->User->getUserDetailsAgainstEmail($email);

            if(APP_STATUS == "demo"){

                $code = 1234;
                $response['code'] = 200;
            }
            if (count($user_info) > 0) {



                $user_id = $user_info['User']['id'];
                $email   = $user_info['User']['email'];
                $first_name   = $user_info['User']['first_name'];
                $last_name   = $user_info['User']['last_name'];
                $full_name   = $first_name. ' '.$last_name;

                $email_data['to'] = $email;
                $email_data['name'] = $full_name;
                $email_data['subject'] = "reset your password";
                $email_data['message'] = "You recently requested to reset your password for your ".APP_NAME." account  with the e-mail address (".$email."). 
Please enter this verification code to reset your password.<br><br>Confirmation code: <b></b>".$code."<b>";

                if(APP_STATUS == "live"){

                    $response = Utility::sendMail($email_data);
                }




                //  $response['ErrorCode']  = 0;
                if ($response['code'] == 200) {

                    $this->User->id = $user_id;

                    $savedField     = $this->User->saveField('token', $code);
                    $result['code'] = 200;
                    $result['msg']  = "An email has been sent to " . $email . ". You should receive it shortly.";
                } else {

                    $result['code'] = 201;
                    $result['msg']  = $response['msg'];


                }

            } else {

                $result['code'] = 201;
                $result['msg']  = "Email doesn't exist";
            }



            echo json_encode($result);
            die();
        }


    }



    public function verifyForgotPasswordCode()
    {
        $this->loadModel('User');


        if ($this->request->isPost()) {
            $json = file_get_contents('php://input');

            $data = json_decode($json, TRUE);
            $code = $data['code'];
            $email = $data['email'];

            $code_verify = $this->User->verifyToken($code,$email);
            $user_info = $this->User->getUserDetailsFromEmail($email);
            if (!empty($code_verify)) {
                $this->User->id = $user_info['User']['id'];
                $this->User->saveField('token',0);

                $user_info = $this->User->getUserDetailsFromEmail($email);
                $result['code'] = 200;
                $result['msg']  = $user_info;
                echo json_encode($result);
                die();
            } else {
                $result['code'] = 201;
                $result['msg']  = "invalid code";
                echo json_encode($result);
                die();
            }
        }
    }

    public function changeEmailAddress()
    {
        $this->loadModel('User');

        if ($this->request->isPost()) {
            $json = file_get_contents('php://input');
            //$json = $this->request->data('json');
            $data = json_decode($json, TRUE);


            $user_id        = $data['user_id'];
            $email        = $data['email'];


            $email_exist = $this->User->editIsEmailAlreadyExist($email, $user_id);

            $user_details = $this->User->getUserDetailsFromID($user_id);
            if(count($user_details) > 0) {

                $db_email = $user_details['User']['email'];

                if ($db_email == $email) {


                    $result['code'] = 200;
                    $result['msg'] = $user_details;
                    echo json_encode($result);
                    die();
                }

                if ($email_exist > 0) {

                    $result['code'] = 201;
                    $result['msg'] = "This email has already been registered";
                    echo json_encode($result);
                    die();
                }
                $code = Utility::randomNumber(4);

                if(APP_STATUS == "demo"){

                    $code = 1234;
                    $response['code'] = 200;
                }


                $user_id = $user_details['User']['id'];
                $first_name = $user_details['User']['first_name'];
                $last_name = $user_details['User']['last_name'];
                $full_name = $first_name . ' ' . $last_name;

                $email_data['to'] = $email;
                $email_data['name'] = $full_name;
                $email_data['subject'] = "change your email address";
                $email_data['message'] = "You recently requested to update your email for your " . APP_NAME . " account. 
Please enter this verification code to reset your email.<br><br>Confirmation code: <b></b>" . $code . "<b>";
                if(APP_STATUS == "live"){

                    $response = Utility::sendMail($email_data);
                }



                //  $response['ErrorCode']  = 0;
                if ($response['code'] == 200) {

                    $this->User->id = $user_id;

                    $savedField = $this->User->saveField('token', $code);
                    $result['code'] = 200;
                    $result['msg'] = "An email has been sent to " . $email . ". You should receive it shortly.";
                } else {

                    $result['code'] = 201;
                    $result['msg'] = $response['msg'];


                }

                echo json_encode($result);
                die();
            }

        }

    }





    public function verifyPhoneNo()
    {

        $this->loadModel('PhoneNoVerification');
        if ($this->request->isPost()) {


            $json = file_get_contents('php://input');

            $data = json_decode($json, TRUE);

            $phone_no = $data['phone'];
            $verify   = $data['verify'];



            $created                  = date('Y-m-d H:i:s', time() - 60 * 60 * 4);
            $phone_verify['phone_no'] = $phone_no;

            $phone_verify['created']  = $created;

            /*****demo cod
            if(APP_STATUS == "demo") {
            $output['code'] = 200;
            $output['msg'] = "demo";

            echo json_encode($output);
            die();
            }
            /******end demo code*****/
            if ($verify == 0) {


                if(APP_STATUS == "demo") {
                    $response['sid']= "";
                    $code     = 1234;

                }else {
                    $code =  Utility::randomNumber(4);
                    $response = Utility::sendSmsVerificationCurl($phone_no, VERIFICATION_PHONENO_MESSAGE . ' ' . $code);

                }

                $phone_verify['code']     = $code;

                if (array_key_exists('code', $response)){


                    $output['code'] = 201;
                    $output['msg']  = $response['message'];
                    echo json_encode($output);
                    die();


                }else{



                    if (array_key_exists('sid', $response)){



                        $this->PhoneNoVerification->save($phone_verify);


                        $output['code'] = 200;

                        $output['msg']  = "code has been generated and sent to user's phone number";
                        echo json_encode($output);
                        die();


                    }

                }





            } else {
                $code_user = $data['code'];
                if ($this->PhoneNoVerification->verifyCode($phone_no, $code_user) > 0) {
                    $output['code'] = 200;
                    $output['msg']  = "successfully code matched";
                    /*$this->PhoneNoVerification->deleteAll(array(
                        'phone_no' => $phone_no
                    ), false);*/

                    echo json_encode($output);
                    die();

                } else {

                    $output['code'] = 201;
                    $output['msg']  = "invalid code";

                    echo json_encode($output);
                    die();

                }

            }
        }


    }


    public function changePhoneNo()
    {
        $this->loadModel('User');

        if ($this->request->isPost()) {
            $json = file_get_contents('php://input');
            //$json = $this->request->data('json');
            $data = json_decode($json, TRUE);


            $user_id        = $data['user_id'];
            $phone        = $data['phone'];


            $phone_exist = $this->User->editIsphoneNoAlreadyExist($phone, $user_id);

            $user_details = $this->User->getUserDetailsFromID($user_id);
            if(count($user_details) > 0) {

                $db_phone = $user_details['User']['phone'];

                if ($db_phone == $phone) {


                    $result['code'] = 200;
                    $result['msg'] = $user_details;
                    echo json_encode($result);
                    die();
                }

                if ($phone_exist > 0) {

                    $result['code'] = 201;
                    $result['msg'] = "This phone has already been registered";
                    echo json_encode($result);
                    die();
                }



                $response =  $this->verifyPhoneNo($phone,$user_id,0);


                echo json_encode($response);
                die();
            }

        }

    }


    public function verifyChangeEmailCode()
    {
        $this->loadModel('User');


        if ($this->request->isPost()) {
            $json = file_get_contents('php://input');

            $data = json_decode($json, TRUE);
            $code = $data['code'];
            $email = $data['new_email'];
            $user_id = $data['user_id'];
            $user_details = $this->User->getUserDetailsFromID($user_id);
            if(count($user_details) > 0) {

                $db_email = $user_details['User']['email'];
                $code_verify = $this->User->verifyToken($code, $db_email);
                // $user_details = $this->User->getUserDetailsFromEmail($email);
                if (!empty($code_verify) && $code > 0) {
                    $email_change['email'] = $email;
                    $email_change['token'] = 0;
                    $this->User->id = $user_id;
                    $this->User->save($email_change);

                    $user_details = $this->User->getUserDetailsFromEmail($email);
                    $result['code'] = 200;
                    $result['msg'] = $user_details;
                    echo json_encode($result);
                    die();
                } else {
                    $result['code'] = 201;
                    $result['msg'] = "invalid code";
                    echo json_encode($result);
                    die();
                }
            }else{

                Message::EMPTYDATA();
                die();

            }
        }
    }

    public function changePassword()
    {
        $this->loadModel('User');

        if ($this->request->isPost()) {
            $json = file_get_contents('php://input');
            //$json = $this->request->data('json');
            $data = json_decode($json, TRUE);

            if(APP_STATUS == "demo") {

                $result['code'] = 201;
                $result['msg']  = "You cannot change demo account password";
                echo json_encode($result);
                die();
            }
            $user_id        = $data['user_id'];
            $this->User->id = $user_id;
            $email          = $this->User->field('email');

            $old_password   = $data['old_password'];
            $new_password   = $data['new_password'];


            if ($this->User->verifyPassword($email, $old_password)) {

                $this->request->data['password'] = $new_password;
                $this->User->id                  = $user_id;


                if ($this->User->save($this->request->data)) {

                    echo Message::DATASUCCESSFULLYSAVED();

                    die();
                } else {


                    echo Message::DATASAVEERROR();
                    die();


                }

            } else {

                echo Message::INCORRECTPASSWORD();
                die();

            }


        }

    }



    public function changePasswordForgot()
    {
        $this->loadModel('User');


        if ($this->request->isPost()) {
            $json = file_get_contents('php://input');
            //$json = $this->request->data('json');
            $data = json_decode($json, TRUE);


            $email        = $data['email'];

            $new_password   = $data['password'];




            $this->request->data['password'] = $new_password;

            $email_details = $this->User->getUserDetailsAgainstEmail($email);


            $user_id = $email_details['User']['id'];
            $this->User->id = $user_id;
            if ($this->User->save($this->request->data)) {

                $user_info = $this->User->getUserDetailsFromID($user_id);
                $result['code'] = 200;
                $result['msg']  = $user_info;
                echo json_encode($result);
                die();
            } else {


                echo Message::DATASAVEERROR();
                die();


            }

        } else {

            echo Message::INCORRECTPASSWORD();
            die();




        }

    }








    public function showLanguages(){

        $this->loadModel('Language');




        if ($this->request->isPost()) {
            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);



            $languages = $this->Language->getOnlyActiveLanguages();





            $output['code'] = 200;

            $output['msg'] = $languages;


            echo json_encode($output);


            die();


        }


    }
   
    public function sendMessageNotification()
    {
        $this->loadModel("User");
        $this->loadModel("Inbox");

         if ($this->request->isPost()) {
            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);


            $sender_id = $data['sender_id'];
            $receiver_id = $data['receiver_id'];
            $message = $data['message'];






            $receiver_details =  $this->User->getUserDetailsFromID($receiver_id);
            $sender_details =  $this->User->getUserDetailsFromID($sender_id);





            /*********************************START NOTIFICATION******************************/

            $notification['to'] = $receiver_details['User']['device_token'];




            $notification['notification']['title'] = "new message";
            $notification['notification']['body'] = $message;
            $notification['notification']['sender_id'] = $sender_details['User']['id'];
            $notification['notification']['receiver_id'] = $receiver_details['User']['id'];
           // $notification['notification']['image'] = $sender_details['User']['profile_pic'];
            //$notification['notification']['name'] = $sender_details['User']['username'];
            $notification['notification']['badge'] = "1";
            $notification['notification']['sound'] = "default";
            $notification['notification']['icon'] = "";
            $notification['notification']['type'] = "message";


            $notification['data']['title'] = "new message";
            // $notification['data']['name'] = $sender_details['User']['username'];
            $notification['data']['body'] = $message;
            $notification['data']['icon'] = "";
            $notification['data']['badge'] = "1";
            $notification['data']['sound'] = "default";
            $notification['data']['type'] = "message";
            $notification['data']['sender_id'] = $sender_details['User']['id'];
           $notification['data']['receiver_id'] = $receiver_details['User']['id'];


            $result = Utility::sendPushNotificationToMobileDevice(json_encode($notification));



            /*********************************END NOTIFICATION******************************/
             $inbox['sender_id'] = $sender_id;
             $inbox['receiver_id'] = $receiver_id;
             $inbox['message'] = $message;

             $inbox_details = $this->Inbox->ifInboxExist($sender_id,$receiver_id);
             if(count($inbox_details) > 0){
                 $inbox_id = $inbox_details['Inbox']['id'];;
                 $this->Inbox->id = $inbox_details['Inbox']['id'];
                 $this->Inbox->save($inbox);


             }else {


                 $this->Inbox->save($inbox);
                 $inbox_id = $this->Inbox->getInsertID();

             }

             $details = $this->Inbox->getDetails($inbox_id);




            $output['code'] = 200;
            $output['msg'] = $details;
            echo json_encode($output);


            die();
        }

    }






    public function sendCustomNotification()
    {
        $this->loadModel("User");
        $this->loadModel("Inbox");

        if ($this->request->isPost()) {
            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);



            $result = Utility::sendPushNotificationToMobileDevice($json);




            $output['code'] = 200;
            $output['msg'] = $result;
            echo json_encode($output);


            die();
        }

    }








    public function searchUsers()
    {

        $this->loadModel("User");
        $this->loadModel("Friend");
        $this->loadModel("RoomMember");

        if ($this->request->isPost()) {
            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);

            $keyword = $data['keyword'];
            $user_id = $data['user_id'];

            if (strlen($keyword) > 0) {


                $users = $this->User->getSearchResults($keyword, $user_id);


                $output['code'] = 200;

                $output['msg'] = $users;


                echo json_encode($output);


                die();


            }

            Message::EMPTYDATA();
            die();


        }
    }






    public function showSettingsAgainstType()
    {


        $this->loadModel("Setting");


        if ($this->request->isPost()) {
            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);

            $types = $data['types'];





            if(count($types) > 0) {

                $type = array();
                foreach ($types as $key_fr => $val) {


                    $type[$key_fr] = $val['type'];


                }


                $setting_details = $this->Setting->getSettingsAgainstType($type);



                $output['code'] = 200;

                $output['msg'] = $setting_details;


                echo json_encode($output);


                die();

            }
        }
    }

    public function getCities()
    {


        $this->loadModel("City");


        if ($this->request->isPost()) {
            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);

            $country_id = $data['country_id'];


            $cities = $this->City->getCitiesAgainstCountry($country_id);



            $output['code'] = 200;

            $output['msg'] = $cities;


            echo json_encode($output);


            die();


        }
    }



    public function showUserDetails()
    {


        $this->loadModel("User");



        if ($this->request->isPost()) {
            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);

            $user_id = $data['user_id'];



            $userDetails = $this->User->getUserDetailsFromID($user_id);


            $output['code'] = 200;

            $output['msg'] = $userDetails;


            echo json_encode($output);


            die();


        }
    }




  public function showKeywords(){

        $this->loadModel('BlockKeyword');




        if ($this->request->isPost()) {
            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);


            if(isset($data['id'])){

                $details = $this->BlockKeyword->getDetails($data['id']);

            }else{

                $details = $this->BlockKeyword->getAll();
            }




            if(count($details) > 0) {


                $output['code'] = 200;

                $output['msg'] = $details;


                echo json_encode($output);


                die();
            }else{


                Message::EMPTYDATA();
                die();
            }

        }


    }
    public function showDriverDetails()
    {


        $this->loadModel("User");



        if ($this->request->isPost()) {
            $json = file_get_contents('php://input');
            $data = json_decode($json, TRUE);

            $user_id = $data['user_id'];



            $userDetails = $this->User->getDriverDetails($user_id,"driver");


            $output['code'] = 200;

            $output['msg'] = $userDetails;


            echo json_encode($output);


            die();


        }
    }


    



}







?>