<?php


class Match extends AppModel
{
    public $useTable = 'match';

    public $belongsTo = array(
        'User' => array(
            'className' => 'User',
            'foreignKey' => 'user_id',
            'type' => 'INNER'


        ),

        'OtherUser' => array(
            'className' => 'User',
            'foreignKey' => 'other_user_id',
            'type' => 'INNER'


        ),
    );

    public function getDetails($id)
    {

        return $this->find('first', array(
            'conditions' => array('Match.id' => $id)
        ));

    }

    public function checkDuplicate($user_id,$other_user_id)
    {

        return $this->find('first', array(
            'conditions' => array(
                'OR' =>
                    array(
                        array('AND' => array(
                            array('Match.user_id' => $user_id),
                            array('Match.other_user_id' => $other_user_id),

                        )),
                        array('AND' => array(
                            array('Match.user_id' => $other_user_id),
                            array('Match.other_user_id' => $user_id),

                        )),
                    )),
            'recursive' => -1


        ));


    }

    public function getMatches($user_id)
    {
        $this->Behaviors->attach('Containable');
        return $this->find('all', array(
            'conditions' => array(

                "OR" => array (
                    "Match.user_id" => $user_id,
                    "Match.other_user_id" => $user_id,

                ),

        ),
            'contain' => array(
                'User.UserImage','OtherUser.UserImage'
            )

            ));

    }

}

?>